;Self disasming :example of using dizx32 
;---------------------------------------
;Creates log-file log666.log & write to it each instruction & NOP.
; (c) necr0mancer Feb-2002
;



include dizx32def.inc
include win.inc
include kernel32.inc

includelib import32.lib

extrn   ExitProcess:near

        .586p
        .model flat

        .data
xxx output<>
a	dd 	0
b	db 	0
c	dw 	0
y	dd	0
x	dw	0


log_file db "log666.log",0

        .code

FakeCode:
	movzx ecx,byte ptr[ebp+5]

	inc esi
	inc ch
	bt ebx,0


	db 0ebh,0d9h

	db 66h,0ffh,15h,90h,90h,90h,90h,90h

	db 0ebh,0d9h

	aam

	repz movsb
	test edx,12345678h

	in ax,dx
	in al,dx

comment  #
	imul eax,edx
	imul ecx,edx
	imul ebp,edx
	imul ebx,ebp
abbb:
	imul eax,edx,12345678h

	imul ax,67
	imul eax,12345678h


	enter 16,3
	enter 36,9
	enter 16,3
	enter 36,9
	enter 16,3
	enter 36,9


		div ax
		div al
		div bl
		div ebp
		div bp
		div eax
		div ecx

		div a


		dec al
		dec ax
		dec a

		cpuid
                mov eax,a                               ;5
                mov ebx,a                               ;6

		cmp a,34h
		cmp eax,eax
		cmp eax,a
		cmp ebx,23h
		cmp ebx,a
		cmp ebx,ecx

		clc
		cbw
		cwde

                mov bx,1234h

		add eax,12h
		add ecx,2
		


		mov [ebp*2+ecx+12345678h],12345678h

		mov eax,[esp+24]
		mov eax,[esp+45]

		bswap eax
		bswap ebx

		bsf eax,ebx
		bsf ebx,ecx
		bsf dx,a
		bsf edx,a
	#
		aaa
		aad
		aam
		aas
		adc al,5

                mov eax,12345678h			;5
		mov ebx,ecx                             ;2
                mov al,12h
                mov bl,12h
                mov ebx,12345678h

_start:
		int 3

		mov edx,offset log_file
		call fcreate
		xchg eax,ebx

		push ebx

		push 2048
		push GMEM_FIXED	
		call GlobalAlloc
		xchg eax,edi
		pop ebx

		push edi
		call dizx32_init				;unpack tables

 	        mov esi,offset  FakeCode

_test_cycle:
		
		push edi					;tables
		push offset xxx                                 ;output
		push esi					;next cmd.
                call dizx32

		cmp eax,-1
		je ___ex


;-------------------------------
;Input:ebx=handle file
;      ecx=count of bytes to write
;      edi=offset of bufer

		push edi

		mov edi,esi					;disasmed command
		mov ecx,eax
		call fwrite

		push 90h					;nop
		mov edi,esp
		mov ecx,1
		call fwrite
		pop ecx

		pop edi

                add esi,eax				;next commnad
		jmp _test_cycle

___ex:
		call fclose

		call GlobalFree

                push    0
                call ExitProcess

include ring3krn.inc 
include dizx32.inc

end     _start